\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.


read("c-curve-defines.gp");

check_count = 0;
check_exact(got,want, name="") =
{
  check_count++;
  if(got!= want,
     print("\nwrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count));
}

\\-----------------------------------------------------------------------------

D_sub_S(k) = D(k) - S(k);
check_exact(vector(100,k,my(k=k-1); D_sub_S(k)), vector(100,k,my(k=k-1); D(k)-S(k)))

D_sub_S(k) = (2^k - S(k))/2 - S(k);
check_exact(vector(100,k,my(k=k-1); D_sub_S(k)), vector(100,k,my(k=k-1); D(k)-S(k)))

D_sub_S(k) = 1/2*2^k - 3/2*S(k);
check_exact(vector(100,k,my(k=k-1); D_sub_S(k)), vector(100,k,my(k=k-1); D(k)-S(k)))

\\-----------------------------------------------------------------------------
\\ ratios

for(k=0,30, print("k="k"  ",S(k+1)/S(k)*1.0));

\\-----------------------------------------------------------------------------

\\ if S(k) <= 1/3*2^k
\\ then S(k+1) = S(k) + 2*S(k-2)
\\             < 1/3*2^k + 2*1/3*2^(k-2)
\\             = (1/3*1/2 + 2*1/3*1/8) * 2^(k+1)
\\             = 1/4 * 2^(k+1) < 1/3*2^(k+1)

\\ then -S(k) < -lower*S(k-1)
\\
\\ then -S(k) > -upper*S(k-1)
\\ then -1/upper*S(k) > -S(k-1)
\\ then -S(k-1) < -1/upper*S(k)
\\ S(k) < 2*S(k-1)
\\ S(k-1) > 1/2*S(k)
\\ 

\\ if S(k) <= 1/3*2^k
\\ then S(k+1) = 3*S(k) -3*S(k-1) +3*S(k-2) + ... - 8*S(k-8)
\\             < 3*1/3*2^k - 3*0 + 3*1/3*2^(k-2) + ...


\\ 3 - 3 + 3 - 2 - 4 + 8 - 8 +16 - 8 == 5

\\ S(k) < 2*S(k-1)
\\ S(k) > 19/20*S(k-1)
upper = 1.96;
lower = 0;
{
  my(r =   3* 1/3 *2^-1
        -  3* 1/3 *2^-2 * 1
        +  3* 1/3 *2^-3
        -  2* 1/3 *2^-4 * 1
        -  4* 1/3 *2^-5 * 1
        +  8* 1/3 *2^-6
        -  8* 1/3 *2^-7 * 1
        + 16* 1/3 *2^-8
        -  8* 1/3 *2^-9 * 1
     );
  print("S(k) < 2^k * "r" = ",r*1.0);
}

\\ {
\\   my(r =   3 
\\         -  3 \  <= 0
\\         +  3 /
\\         -  2 \
\\         -  4 |
\\         +  8 /  +2
\\         -  8 \
\\         + 16 /  +8
\\         -  8
\\      );
\\ }
{
  my(r =3* 1/3 *2^-1
        \\ -  3* 1/3 *2^-2
        \\ +  3* 1/3 *2^-3

        \\ -  2* 1/3 *2^-4
        \\ -  4* 1/3 *2^-5
        \\ +  8* 1/3 *2^-6
        +  2* 1/3 *2^-6

        \\ -  8* 1/3 *2^-7
        \\ + 16* 1/3 *2^-8
        +     8* 1/3 *2^-8

        \\ -  8* 1/3 *2^-9
     );
  print("S(k+1) < 2^(k+1) * "r" = ",r*1.0);
}


\\   my(r =   2          2         -1
\\         -  3     3  = 0         -2
\\         +  3  -  3    0         -3
\\         -  2  +  3    1         -4
\\         -  4  -  2   -6         -5
\\         +  8  -  4    4         -6
\\         -  8  +  8    0         -7
\\         + 16  -  8    8         -8
\\         -  8  + 16    8         -9
\\               -  8   -8

{
  my(r =  2* 1/3 *2^-1    \\ = 1/3
        + 1* 1/3 *2^-4
        + -6* 1/3 *2^-5
        + 4* 1/3 *2^-6
        + 8* 1/3 *2^-8
        + 8* 1/3 *2^-9
        + -8* 1/3 *2^-10
     );
  print("one down "r" = ",r*1.0);
}


\\   my(r =   1            1         -1
\\         -  3     2*3  = 3         -2
\\         +  3  -  2*3   -3         -3
\\         -  2  +  2*3    4         -4
\\         -  4  -  2*2   -8         -5
\\         +  8  -  2*4    0         -6
\\         -  8  +  2*8    8         -7
\\         + 16  -  2*8    0         -8
\\         -  8  + 2*16    8         -9
\\               -  2*8   -16

{
  my(r =  1* 1/3 *2^-1        \\ = 1/6
        + 3* 1/3 *2^-2        \\ = 1/4   are 5/12 > 1/3
        + 4* 1/3 *2^-4
        + 4* 1/3 *2^-6
        + 8* 1/3 *2^-7
        + 8* 1/3 *2^-9

        + -3* 1/3 *2^-3
        + -8* 1/3 *2^-5
        + -16* 1/3 *2^-10
     );
  print("2*down "r" = ",r*1.0);
}
quit

{
  my(pos=lower, neg=upper);
  my(r =   3*pos^(-1+1)
        -  3*neg^(-2+1)
        +  3*pos^(-3+1)
        -  2*neg^(-4+1)
        -  4*neg^(-5+1)
        +  8*pos^(-6+1)
        -  8*neg^(-7+1)
        + 16*pos^(-8+1)
        -  8*neg^(-9+1));
  print("S > "r" = ",r*1.0);
}

print("1/upper = ",1/upper);
print("1/lower = ",1/lower);